#include<fcntl.h>
#include<io.h>

static char DefWord1Str[] = "0123456789_ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"; //ᨬ ᫮(⨭) -㬮砭
static char DefWord2Str[] = "񦧨"; //ᨬ ᫮(ਫ) -㬮砭 -㬮砭

typedef struct T_INFO_FUN
{
   char NameFun[256];
   char total[256];
   char path[MAX_PATH];
   unsigned long num_str;

}T_INFO_FUN; 

#define MAX_FIND_FUNS 1024

// OEM-ਠ
static int toupcOEM(int ch )
{
   ch &= 0xFF;

   if( ch >= 'a' && ch <= 'z' )
        return  ch - ('a' - 'A');
   else if( ch >= (unsigned char)'' && ch <= (unsigned char)'')
        return  ch - ('' - '');
   else if( ch >= (unsigned char)'' && ch <= (unsigned char)'')
        return  ch - ('' - '');
   else if( ch == '' )
        return '';
   else return  ch;
}


static void ConvertToOEM( char *str )
{
     EditorConvertText ect;
     ect.Text       = str;
     ect.TextLength = strlen(str);
     //
     _Info.EditorControl( ECTL_EDITORTOOEM, &ect );
}

//஢ઠ  ᨬ-ࠧ⥫
static CheckDelSymbol( char Symbol ){
   int stat = 1;
   char StrSymb[2] = { Symbol, '\0' };
   //⨬ ᨬ  OEM
   ConvertToOEM( StrSymb );
   Symbol = StrSymb[0];

   //᫨  -ᨬ  室  祭 ᨬ ப
   if( (strchr( DefWord1Str, Symbol )  || strchr( DefWord2Str, Symbol )) )
      stat = 0;                  

   return stat;
}

#define LenCurWord 1024

//墠뢠 楫 ᫮  ⥪饩 樨  ।
static void GetCurWord( char *CurWord, char *StringText, int StringLength, int CurPos, int *BegPos ){

   if( StringLength > CurPos ){
     char *CurText = StringText + CurPos;
  
     if( *CurText && *CurText != ' ' && *CurText != '\n' && *CurText != '\t' && *CurText != '\r' ){
  
        char *EndWord = CurText;
        while( *EndWord && !CheckDelSymbol( *EndWord) ) EndWord++;
     
        char *BegWord = CurText;
        while( *BegWord && (BegWord-StringText) >= 0 && !CheckDelSymbol(  *BegWord) ) BegWord--;
        if( BegWord != CurText ) BegWord++;
     
        if( *BegWord != '\0' ){
           if( (EndWord-BegWord) < LenCurWord ){
              strncpy( CurWord, BegWord, (EndWord-BegWord) );
              *(CurWord+(EndWord-BegWord)) = '\0';
           } 
           else{
              strncpy( CurWord, BegWord, LenCurWord-1 );
              *(CurWord+(LenCurWord-1)) = '\0'; 
           }

           if( BegPos ) *BegPos = BegWord - StringText;//AV 02.12.99

           ConvertToOEM( CurWord );
        }
     }
   }
}

static void SetEditorPosition( struct EditorInfo *ei, int CurLine, int CurPos, int NoCenter, int NoPos, int Reverse ){
   struct EditorSetPosition esp;

   esp.CurLine   = CurLine;
   esp.CurPos    = CurPos;
   esp.CurTabPos = -1;   
   esp.Overtype  = -1;
   esp.LeftPos   = -1;
   esp.TopScreenLine = -1;

   if( !NoPos ){
      // 祭  業஢     室  । ࠭  Y
      int CenterY;
      //祭  業஢  室  । ࠭  X
      int CenterX;
      //ਧ 室  । ࠭
      int OutScreen;
      //⥪  ⭮⥫쭮  ࠭
      int LocCurLine;

      int UpY = (int)floor(ei->WindowSizeY/4.);             /*  ࠭*/
      int DnY = (int)floor( ei->WindowSizeY/4.*3.+ 0.5);    /*  ࠭, 㣫塞   ஭*/
  
      if( Reverse ) CenterY = CurLine - UpY;
      else{         
         CenterY = CurLine - DnY;
         if( NoCenter && CenterY < 0 ) CenterY = CurLine - UpY;// ࢮ ࠭
      }
      if( CenterY < 0 ) CenterY = 0;

      CenterX    = CurPos - (int)( ei->WindowSizeX/2);
      if( CenterX < 0 ) CenterX = 0;

      LocCurLine = CurLine - ei->TopScreenLine;

      if( LocCurLine < 0 || LocCurLine >= ei->WindowSizeY )
         OutScreen = 1;
      else
         OutScreen = 0;

      //ExtTestMessage( "NoCenter", NoCenter );

      //㡥६  業 (⮡ ᠣ  뢠  ⥪)
      if( (NoCenter && LocCurLine >= UpY && LocCurLine <= DnY) || OutScreen  )    
         esp.TopScreenLine = CenterY;                                                                               
      else 
         esp.TopScreenLine = ei->TopScreenLine;

      //AV 15.12.99 諨  ࠭ ࠭  X
      if( CurPos < ei->LeftPos )
         esp.LeftPos = CenterX;//AV 15.12.99
   }
   //
   _Info.EditorControl( ECTL_SETPOSITION, (void*)&esp );

}


//窠 ⥪  䠩  esr->StringBuff
static bool File2StringBuff( FCSBPARM *_parm, char *FilePath, char **Buff, unsigned long *len )
{
   int CurHandle;
   bool stat;
   int mode = _parm->IsFilePrj ? O_RDONLY : O_RDONLY | O_BINARY;

   if( (CurHandle = open( FilePath, mode )) >= 0 ){

      *len = filelength( CurHandle );

      if( *len > 0 &&           
            (*Buff == NULL && (*Buff = (char*)malloc( *len + 1 )) != NULL) ||
            (*Buff != NULL && (*Buff = (char*)realloc( *Buff, *len + 1 )) != NULL)
        ){      
       
        stat = true;      
      }
      else
         stat = false;

      if( stat == true && read( CurHandle, (void*)(*Buff), *len ) != *len )
         stat = false;
      else{
         if( stat == true ){ 
            *(*Buff + *len) = '\0';
         }
      }
 
      if( close( CurHandle ) ) stat = false; 

   }else
      stat = false;

   return stat;
}


static bool GetFunInfo( char *BegStr, T_INFO_FUN *info )
{
   char *BegPath, *BegNum, *EndNum;

   if( BegStr != NULL ){
      memset( info, 0, sizeof(T_INFO_FUN) );
      BegPath = strchr( BegStr, '?' );      
      if( BegPath != NULL ){   
         strncpy( info->NameFun, BegStr, BegPath-BegStr );
         info->NameFun[BegPath-BegStr] = '\0';
         BegNum = strchr( BegPath+1, '?' );
         if( BegNum != NULL ){            
            char Tmp[512] = "";
            //砥 + 䠩
            strncpy( info->path, BegPath+1, BegNum-BegPath-1 );
            *(info->path+(BegNum-BegPath-1)) = '\0';
            //砥  ப  ன 㭪
            EndNum = strchr( BegNum+1, '?' );
            strncpy( Tmp, BegNum+1, EndNum-BegNum-1 );
            *(Tmp+(EndNum-BegNum-1)) = '\0';
            info->num_str = atoi( Tmp );   
            sprintf( info->total, " %-30s %-34s %u", info->NameFun, info->path, info->num_str ); 
            return true;
         }
      }         
   }
   return false;
}

static stristr( char *Str1, char *Str2, int len )
{
   while( len > 0 )
   {
      len--;
      if( toupcOEM(*Str1++) != toupcOEM(*Str2++) )
         return 1;         
   }
   return 0;
}

//********************************************************************
//    䠩 ஥  㭪樨
//********************************************************************
static bool GetFun( FCSBPARM *_parm, char *FunName, char *Buff, bool *skip_menu )
{
   bool ret = false, SymbEq;
   bool Beg = false;
   char *BegStr = Buff;
   T_INFO_FUN info_fun[MAX_FIND_FUNS];
  
   if( toupcOEM(*Buff) == toupcOEM(*FunName) ) // ᨬ ᮢ
      SymbEq = true;
   else
      SymbEq = false;

   for( ;; )
   {    
      if( SymbEq == true )
      {                   
         if( stristr( BegStr, FunName, strlen(FunName) ) == 0 )
         {
            Beg = true;
            GetFunInfo( BegStr, &info_fun[_parm->num_find_funs] );
            
            _parm->num_find_funs++;//-  㭪権
            if( _parm->num_find_funs == MAX_FIND_FUNS )
               break;               

         }else if( Beg == true ) 
            break; //稫 室騥 ப
      }

      while( *BegStr != '\n' && *BegStr != 0 ) BegStr++;

      if( *BegStr == 0 )
         break; //䠩 稫
      else
         BegStr++;

      if( SymbEq == false )
      {
         if( toupcOEM(*BegStr) == toupcOEM(*FunName) )
            SymbEq = true; //砫  ப, 稭  㦭  㪢
      }   
   }

   if( _parm->num_find_funs != 0 ){
     int num_choice;

     if( _parm->num_find_funs > 1 ){       
        struct FarMenuItem MenuItems[MAX_FIND_FUNS];
        memset(MenuItems,0,sizeof(MenuItems));
        for( int i = 0; i < _parm->num_find_funs; i++ )
           strncpy( MenuItems[i].Text, info_fun[i].total, 256 );  
        MenuItems[0].Selected = TRUE;  
      
        num_choice = _Info.Menu(
           _Info.ModuleNumber,
           -1, -1, 0,
           FMENU_AUTOHIGHLIGHT,
           GetMsg( MesMenuGoToFun ),
           NULL,
           "Contents",
           NULL,
           NULL,
           MenuItems, 
           _parm->num_find_funs );
     }else
        num_choice = 0;
      
     if( num_choice == -1 ){ 
        *skip_menu = true; 
        ret = false;
     } 
     else{
       strcpy( _parm->FilePath, info_fun[num_choice].path );
       _parm->NumStr = info_fun[num_choice].num_str;
       ret = true;      
     } 
   }

   return ret;
}

//砥   䠩
static bool GetPathFromNameFile( char *FileName, char *CurPath )
{        
   char *PosEndPath;
   if( (PosEndPath = strrchr(FileName,'\\')) != NULL ){
      int Num = PosEndPath - FileName;
      lstrcpyn( CurPath, FileName, Num+1 );
      *(CurPath + Num + 1) = '\0';            
      return true;
   }
   else
      return false;
}

//ᤥ      㭪権
static void MakePathToBaseNameFunc( bool ret, char *PathFileName, char *CurPath )
{
  if( ret ){ 
     strcpy( PathFileName, CurPath );
     lstrcat( PathFileName, "\\" );
     lstrcat( PathFileName, "fcsbprj$.Far" );
  }else 
     lstrcpy( PathFileName, "fcsbprj$.Far" );
}

//     㭪権
static bool FindInBaseNameFunc( FCSBPARM *_parm, char *FunName, char *CurPath, char *PathFileName, bool InCurPath, bool *skip_menu )
{
  bool find = false, ret; 
  char *TmpStr = NULL; 
  unsigned long LenTmpStr;

  ret = File2StringBuff( _parm, _parm->FilePath, &TmpStr, &LenTmpStr ); 

  if( ret && LenTmpStr != 0 && TmpStr != NULL )        
     find = GetFun( _parm, FunName, TmpStr, skip_menu );
  
  if( TmpStr )
     free( TmpStr );

  if( find && InCurPath )
     strcpy( PathFileName, _parm->FilePath );
  else if( find ){
     strcpy( PathFileName, CurPath );
     strcat( PathFileName, "\\" );
     strcat( PathFileName, _parm->FilePath );
  }
  return find; 
}

//********************************************************************
//  室  㭪樨,  ன ⮨
//********************************************************************
static void GoToFun( FCSBPARM *_parm )
{
   bool AlreadyPrj = false;
   bool skip_menu = false;
   EditorGetString egs;

   memset( &egs, 0, sizeof(EditorGetString) );  

   egs.StringNumber = -1; // ⥪ ப
   _Info.EditorControl( ECTL_GETSTRING, &egs );

   if( egs.StringText )
   {
      struct EditorInfo ei;
      _Info.EditorControl(ECTL_GETINFO,&ei);

      char FunName[512] = "";
      GetCurWord( FunName, (char *)egs.StringText, egs.StringLength, ei.CurPos, NULL );

      if( *FunName != '\0' )//᫨ ⮨  㭪樨 饬 ,  ᫨  ⮬   堥 :)
      {
         char PathFileName[1024] = "", CurPath[1024] = ""; 
         bool find;

         /*砫 ஡㥬   ᯨ᪥ 㭪権  ⥪饬 ⠫*/
         MakePathToBaseNameFunc( GetPathFromNameFile( (char *)ei.FileName, CurPath ), _parm->FilePath, CurPath ); 
         if( AlreadyPrj == false ){
            if( !stricmp( CurPath, _parm->PathRootPrj ) )
               AlreadyPrj = true;

            find = FindInBaseNameFunc( _parm, FunName, CurPath, PathFileName, true, &skip_menu );
         }

         //⥯ 饬  ஢ 
         if( find == false )
         {
            MakePathToBaseNameFunc( GetPathFromNameFile( CurPath, CurPath ), _parm->FilePath, CurPath ); 
            if( AlreadyPrj == false ){
               if( !stricmp( CurPath, _parm->PathRootPrj ) )
                  AlreadyPrj = true;

               find = FindInBaseNameFunc( _parm, FunName, CurPath, PathFileName, false, &skip_menu );         
            }
         }

         //   ஢  :)
         if( find == false )
         {
            MakePathToBaseNameFunc( GetPathFromNameFile( CurPath, CurPath ), _parm->FilePath, CurPath ); 
            if( AlreadyPrj == false ){
               if( !stricmp( CurPath, _parm->PathRootPrj ) )
                  AlreadyPrj = true;

               find = FindInBaseNameFunc( _parm, FunName, CurPath, PathFileName, false,  &skip_menu );         
            }
         }

         /*⥯ ஡㥬   ᯨ᪥ 㭪権  ୥ ஥ - ஥*/
         /* ᫨   ࠫ    ।饬 ᪥ */
         if( AlreadyPrj == false && find == false )
         {
            AlreadyPrj == true;
            /* RSL-䠩  ७ ஥  */
            if( _Info.CmpName( "*.MAC", ei.FileName, TRUE ) == false ) 
            {
               MakePathToBaseNameFunc( true, _parm->FilePath, _parm->PathRootPrj );   
               find = FindInBaseNameFunc( _parm, FunName, _parm->PathRootPrj, PathFileName, false, &skip_menu );
            }
         }

         if( find == true && *PathFileName != '\0' && _parm->NumStr > 0 )
         {
            if( stricmp( PathFileName, ei.FileName) )
            {
               unsigned long NumStr = _parm->NumStr;

               _Info.Editor(
                 PathFileName,
                 NULL,                                
                 0,
                 0,
                 -1,
                 -1,
                 0,                                     
                 NumStr,
                 1
               );
            }
            else
               SetEditorPosition( &ei, _parm->NumStr, 0, 0, 0, 0 );            
         }
         else
         {
            if( skip_menu != true ){ //᫨ ⪠ ஢쭮  ,  ᮮ饭  㦭
               const char *MsgItems[]={GetMsg(MesMenuGoToFun),GetMsg(MNoFindFun),GetMsg(MesOk)};
               _Info.Message(_Info.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
            }
         }
      }
   }
}